/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.9 Revision 1.339
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.9 2002/12/01 15:48:27 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.339 2010/03/07 02:55:54 vapier Exp $
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
10ECLASS=eutils 5# @ECLASS: eutils.eclass
11INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
12 17
13newdepend sys-devel/patch 18inherit multilib portability
14 19
15DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
16 21
17# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
18# libs in /lib. This is to fix linking problems when you have
19# the .so in /lib, and the .a in /usr/lib. What happens is that
20# in some cases when linking dynamic, the .a in /usr/lib is used
21# instead of the .so in /lib due to gcc/libtool tweaking ld's
22# library search path. This cause many builds to fail.
23# See bug #4411 for more info.
24#
25# To use, simply call:
26#
27# gen_usr_ldscript libfoo.so
28#
29# Note that you should in general use the unversioned name of
30# the library, as ldconfig should usually update it correctly
31# to point to the latest version of the library present.
32#
33# <azarah@gentoo.org> (26 Oct 2002)
34#
35gen_usr_ldscript() {
36 23
37 # Just make sure it exists 24# @FUNCTION: epause
38 dodir /usr/lib 25# @USAGE: [seconds]
39 26# @DESCRIPTION:
40 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
41/* GNU ld script 28# printing a message the user should probably be reading and often used in
42 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
43 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
44 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
45 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
46 See bug #4411 on http://bugs.gentoo.org/ for
47 more info. */
48GROUP ( /lib/libxxx )
49END_LDSCRIPT
50
51 dosed "s:libxxx:$1:" /usr/lib/$1
52
53 return 0
54} 33}
55 34
56# Simple function to draw a line consisting of '=' the same length as $* 35# @FUNCTION: ebeep
57# 36# @USAGE: [number of beeps]
58# <azarah@gentoo.org> (11 Nov 2002) 37# @DESCRIPTION:
59# 38# Issue the specified number of beeps (default of 5 beeps). Useful when
60draw_line() { 39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
61 local i=0 43 local n
62 local str_length="" 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
63 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
64 # Handle calls that do not have args, or wc not being installed ...
65 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
66 then
67 echo "==============================================================="
68 return 0
69 fi
70
71 # Get the length of $*
72 str_length="$(echo -n "$*" | wc -m)"
73
74 while [ "$i" -lt "${str_length}" ]
75 do
76 echo -n "=" 46 echo -ne "\a"
77 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
78 i=$((i + 1)) 48 echo -ne "\a"
49 sleep 1
79 done 50 done
51 fi
52}
80 53
81 echo 54else
82 55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: ecvs_clean
67# @USAGE: [list of dirs]
68# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD.
71ecvs_clean() {
72 [[ -z $* ]] && set -- .
73 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
74 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
75}
76
77# @FUNCTION: esvn_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove .svn directories recursiveley. Useful when a source tarball contains
81# internal Subversion directories. Defaults to $PWD.
82esvn_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85}
86
87# @FUNCTION: eshopts_push
88# @USAGE: [options to `set` or `shopt`]
89# @DESCRIPTION:
90# Often times code will want to enable a shell option to change code behavior.
91# Since changing shell options can easily break other pieces of code (which
92# assume the default state), eshopts_push is used to (1) push the current shell
93# options onto a stack and (2) pass the specified arguments to set.
94#
95# If the first argument is '-s' or '-u', we assume you want to call `shopt`
96# rather than `set` as there are some options only available via that.
97#
98# A common example is to disable shell globbing so that special meaning/care
99# may be used with variables/arguments to custom functions. That would be:
100# @CODE
101# eshopts_push -o noglob
102# for x in ${foo} ; do
103# if ...some check... ; then
104# eshopts_pop
83 return 0 105# return 0
106# fi
107# done
108# eshopts_pop
109# @CODE
110eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p)
116 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
118 else
119 __ESHOPTS_SAVE__[$i]=$-
120 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*"
122 fi
84} 123}
85 124
86# Default directory where patches are located 125# @FUNCTION: eshopts_pop
126# @USAGE:
127# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details.
130eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
138 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
141 fi
142}
143
144# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION:
146# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 147EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 148# @VARIABLE: EPATCH_SUFFIX
149# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 151EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION:
90# Default options for patch 154# Default options for patch:
91EPATCH_OPTS="" 155# @CODE
156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
157# --no-backup-if-mismatch - do not leave .orig files behind
158# -E - automatically remove empty files
159# @CODE
160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 163# List of patches not to apply. Note this is only file names,
93# and not the full path .. 164# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 165EPATCH_EXCLUDE=""
166# @VARIABLE: EPATCH_SINGLE_MSG
167# @DESCRIPTION:
95# Change the printed message for a single patch. 168# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 169EPATCH_SINGLE_MSG=""
170# @VARIABLE: EPATCH_MULTI_MSG
171# @DESCRIPTION:
172# Change the printed message for multiple patches.
173EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
174# @VARIABLE: EPATCH_FORCE
175# @DESCRIPTION:
176# Only require patches to match EPATCH_SUFFIX rather than the extended
177# arch naming style.
178EPATCH_FORCE="no"
97 179
98# This function is for bulk patching, or in theory for just one 180# @FUNCTION: epatch
99# or two patches. 181# @USAGE: [patches] [dirs of patches]
182# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully.
100# 188#
101# It should work with .bz2, .gz, .zip and plain text patches. 189# If you do not specify any options, then epatch will default to the directory
102# Currently all patches should be the same format. 190# specified by EPATCH_SOURCE.
103# 191#
104# You do not have to specify '-p' option to patch, as it will 192# When processing directories, epatch will apply all patches that match:
105# try with -p0 to -p5 until it succeed, or fail at -p5. 193# @CODE
106# 194# ${EPATCH_FORCE} == "yes"
107# Above EPATCH_* variables can be used to control various defaults,
108# bug they should be left as is to ensure an ebuild can rely on
109# them for.
110#
111# Patches are applied in current directory.
112#
113# Bulk Patches should preferibly have the form of:
114#
115# ??_${ARCH}_foo.${EPATCH_SUFFIX} 195# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else
197# *.${EPATCH_SUFFIX}
198# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering.
200# The arch field is used to apply patches only for the host architecture with
201# the special value of "all" means apply for everyone. Note that using values
202# other than "all" is highly discouraged -- you should apply patches all the
203# time and let architecture details be detected at configure/compile time.
116# 204#
117# For example: 205# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
206# for patches to apply.
118# 207#
119# 01_all_misc-fix.patch.bz2 208# Refer to the other EPATCH_xxx variables for more customization of behavior.
120# 02_sparc_another-fix.patch.bz2
121#
122# This ensures that there are a set order, and you can have ARCH
123# specific patches.
124#
125# If you however give an argument to epatch(), it will treat it as a
126# single patch that need to be applied if its a file. If on the other
127# hand its a directory, it will set EPATCH_SOURCE to this.
128#
129# <azarah@gentoo.org> (10 Nov 2002)
130#
131epatch() { 209epatch() {
132 local PIPE_CMD="" 210 _epatch_draw_line() {
133 local STDERR_TARGET="${T}/$$.out" 211 # create a line of same length as input string
134 local PATCH_TARGET="${T}/$$.patch" 212 [[ -z $1 ]] && set "$(printf "%65s" '')"
135 local PATCH_SUFFIX="" 213 echo "${1//?/=}"
214 }
215
216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
217
218 # Let the rest of the code process one user arg at a time --
219 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then
222 local m
223 for m in "$@" ; do
224 epatch "${m}"
225 done
226 return 0
227 fi
228
136 local SINGLE_PATCH="no" 229 local SINGLE_PATCH="no"
230 # no args means process ${EPATCH_SOURCE}
231 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
232
233 if [[ -f $1 ]] ; then
234 SINGLE_PATCH="yes"
235 set -- "$1"
236 # Use the suffix from the single patch (localize it); the code
237 # below will find the suffix for us
238 local EPATCH_SUFFIX=$1
239
240 elif [[ -d $1 ]] ; then
241 # Some people like to make dirs of patches w/out suffixes (vim)
242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
243
244 else
245 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo
248 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
249 eerror
250 eerror " ${EPATCH_SOURCE}"
251 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo
253 die "Cannot find \$EPATCH_SOURCE!"
254 fi
255
256 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;;
261 gz|Z|z) PIPE_CMD="gzip -dc" ;;
262 ZIP|zip) PIPE_CMD="unzip -p" ;;
263 *) ;;
264 esac
265
266 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
267
137 local x="" 268 local x
269 for x in "$@" ; do
270 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
271 # didn't match anything, ignore continue on
272 [[ ! -f ${x} ]] && continue
138 273
139 if [ "$#" -gt 1 ] 274 local patchname=${x##*/}
275
276 # Apply single patches, or forced sets of patches, or
277 # patches with ARCH dependant names.
278 # ???_arch_foo.patch
279 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \
285 ${a} == ${ARCH} ]]
286 then
287 continue
288 fi
289
290 # Let people filter things dynamically
291 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
292 # let people use globs in the exclude
293 eshopts_push -o noglob
294
295 local ex
296 for ex in ${EPATCH_EXCLUDE} ; do
297 if [[ ${patchname} == ${ex} ]] ; then
298 eshopts_pop
299 continue 2
300 fi
301 done
302
303 eshopts_pop
304 fi
305
306 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
307 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
308 einfo "${EPATCH_SINGLE_MSG}"
309 else
310 einfo "Applying ${patchname} ..."
311 fi
312 else
313 einfo " ${patchname} ..."
314 fi
315
316 # most of the time, there will only be one run per unique name,
317 # but if there are more, make sure we get unique log filenames
318 local STDERR_TARGET="${T}/${patchname}.out"
319 if [[ -e ${STDERR_TARGET} ]] ; then
320 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi
322
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
324
325 # Decompress the patch if need be
326 local count=0
327 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then
329 PATCH_TARGET="${T}/$$.patch"
330 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
331
332 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
333 echo
334 eerror "Could not extract patch!"
335 #die "Could not extract patch!"
336 count=5
337 break
338 fi
339 else
340 PATCH_TARGET=${x}
341 fi
342
343 # Check for absolute paths in patches. If sandbox is disabled,
344 # people could (accidently) patch files in the root filesystem.
345 # Or trigger other unpleasantries #237667. So disallow -p0 on
346 # such patches.
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then
349 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi
352
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
354 while [[ ${count} -lt 5 ]] ; do
355 # Generate some useful debug info ...
356 (
357 _epatch_draw_line "***** ${patchname} *****"
358 echo
359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
360 echo
361 _epatch_draw_line "***** ${patchname} *****"
362 ) >> "${STDERR_TARGET}"
363
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
365 (
366 _epatch_draw_line "***** ${patchname} *****"
367 echo
368 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo
370 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
372 ) >> "${STDERR_TARGET}"
373
374 if [ $? -ne 0 ] ; then
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381 break
382 fi
383
384 : $(( count++ ))
385 done
386
387 # if we had to decompress the patch, delete the temp one
388 if [[ -n ${PIPE_CMD} ]] ; then
389 rm -f "${PATCH_TARGET}"
390 fi
391
392 if [[ ${count} -ge 5 ]] ; then
393 echo
394 eerror "Failed Patch: ${patchname} !"
395 eerror " ( ${PATCH_TARGET} )"
396 eerror
397 eerror "Include in your bugreport the contents of:"
398 eerror
399 eerror " ${STDERR_TARGET}"
400 echo
401 die "Failed Patch: ${patchname}!"
402 fi
403
404 # if everything worked, delete the patch log
405 rm -f "${STDERR_TARGET}"
406 eend 0
407 done
408
409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
410 : # everything worked
411}
412epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414
415 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch
427 break
428 fi
429 done
430}
431
432# @FUNCTION: emktemp
433# @USAGE: [temp dir]
434# @DESCRIPTION:
435# Cheap replacement for when debianutils (and thus mktemp)
436# does not exist on the users system.
437emktemp() {
438 local exe="touch"
439 [[ $1 == -d ]] && exe="mkdir" && shift
440 local topdir=$1
441
442 if [[ -z ${topdir} ]] ; then
443 [[ -z ${T} ]] \
444 && topdir="/tmp" \
445 || topdir=${T}
446 fi
447
448 if ! type -P mktemp > /dev/null ; then
449 # system lacks `mktemp` so we have to fake it
450 local tmp=/
451 while [[ -e ${tmp} ]] ; do
452 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
453 done
454 ${exe} "${tmp}" || ${exe} -p "${tmp}"
455 echo "${tmp}"
456 else
457 # the args here will give slightly wierd names on BSD,
458 # but should produce a usable file on all userlands
459 if [[ ${exe} == "touch" ]] ; then
460 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
461 else
462 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
463 fi
464 fi
465}
466
467# @FUNCTION: egetent
468# @USAGE: <database> <key>
469# @MAINTAINER:
470# base-system@gentoo.org (Linux)
471# Joe Jezak <josejx@gmail.com> (OS X)
472# usata@gentoo.org (OS X)
473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
474# @DESCRIPTION:
475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
477# and pw (FreeBSD) used in enewuser()/enewgroup()
478egetent() {
479 case ${CHOST} in
480 *-darwin[678])
481 case "$2" in
482 *[!0-9]*) # Non numeric
483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
484 ;;
485 *) # Numeric
486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
502 ;;
503 esac
504 ;;
505 *-freebsd*|*-dragonfly*)
506 local opts action="user"
507 [[ $1 == "passwd" ]] || action="group"
508
509 # lookup by uid/gid
510 if [[ $2 == [[:digit:]]* ]] ; then
511 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
512 fi
513
514 pw show ${action} ${opts} "$2" -q
515 ;;
516 *-netbsd*|*-openbsd*)
517 grep "$2:\*:" /etc/$1
518 ;;
519 *)
520 type -p nscd >& /dev/null && nscd -i "$1"
521 getent "$1" "$2"
522 ;;
523 esac
524}
525
526# @FUNCTION: enewuser
527# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
528# @DESCRIPTION:
529# Same as enewgroup, you are not required to understand how to properly add
530# a user to the system. The only required parameter is the username.
531# Default uid is (pass -1 for this) next available, default shell is
532# /bin/false, default homedir is /dev/null, there are no default groups,
533# and default params sets the comment as 'added by portage for ${PN}'.
534enewuser() {
535 case ${EBUILD_PHASE} in
536 unpack|compile|test|install)
537 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
538 eerror "Package fails at QA and at life. Please file a bug."
539 die "Bad package! enewuser is only for use in pkg_* functions!"
540 esac
541
542 # get the username
543 local euser=$1; shift
544 if [[ -z ${euser} ]] ; then
545 eerror "No username specified !"
546 die "Cannot call enewuser without a username"
547 fi
548
549 # lets see if the username already exists
550 if [[ -n $(egetent passwd "${euser}") ]] ; then
551 return 0
552 fi
553 einfo "Adding user '${euser}' to your system ..."
554
555 # options to pass to useradd
556 local opts=
557
558 # handle uid
559 local euid=$1; shift
560 if [[ -n ${euid} && ${euid} != -1 ]] ; then
561 if [[ ${euid} -gt 0 ]] ; then
562 if [[ -n $(egetent passwd ${euid}) ]] ; then
563 euid="next"
564 fi
565 else
566 eerror "Userid given but is not greater than 0 !"
567 die "${euid} is not a valid UID"
568 fi
569 else
570 euid="next"
571 fi
572 if [[ ${euid} == "next" ]] ; then
573 for ((euid = 101; euid <= 999; euid++)); do
574 [[ -z $(egetent passwd ${euid}) ]] && break
575 done
576 fi
577 opts="${opts} -u ${euid}"
578 einfo " - Userid: ${euid}"
579
580 # handle shell
581 local eshell=$1; shift
582 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
583 if [[ ! -e ${ROOT}${eshell} ]] ; then
584 eerror "A shell was specified but it does not exist !"
585 die "${eshell} does not exist in ${ROOT}"
586 fi
587 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
588 eerror "Do not specify ${eshell} yourself, use -1"
589 die "Pass '-1' as the shell parameter"
590 fi
591 else
592 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
593 [[ -x ${ROOT}${shell} ]] && break
594 done
595
596 if [[ ${shell} == "/dev/null" ]] ; then
597 eerror "Unable to identify the shell to use, proceeding with userland default."
598 case ${USERLAND} in
599 GNU) shell="/bin/false" ;;
600 BSD) shell="/sbin/nologin" ;;
601 Darwin) shell="/usr/sbin/nologin" ;;
602 *) die "Unable to identify the default shell for userland ${USERLAND}"
603 esac
604 fi
605
606 eshell=${shell}
607 fi
608 einfo " - Shell: ${eshell}"
609 opts="${opts} -s ${eshell}"
610
611 # handle homedir
612 local ehome=$1; shift
613 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
614 ehome="/dev/null"
615 fi
616 einfo " - Home: ${ehome}"
617 opts="${opts} -d ${ehome}"
618
619 # handle groups
620 local egroups=$1; shift
621 if [[ ! -z ${egroups} ]] ; then
622 local oldifs=${IFS}
623 local defgroup="" exgroups=""
624
625 export IFS=","
626 for g in ${egroups} ; do
627 export IFS=${oldifs}
628 if [[ -z $(egetent group "${g}") ]] ; then
629 eerror "You must add group ${g} to the system first"
630 die "${g} is not a valid GID"
631 fi
632 if [[ -z ${defgroup} ]] ; then
633 defgroup=${g}
634 else
635 exgroups="${exgroups},${g}"
636 fi
637 export IFS=","
638 done
639 export IFS=${oldifs}
640
641 opts="${opts} -g ${defgroup}"
642 if [[ ! -z ${exgroups} ]] ; then
643 opts="${opts} -G ${exgroups:1}"
644 fi
645 else
646 egroups="(none)"
647 fi
648 einfo " - Groups: ${egroups}"
649
650 # handle extra and add the user
651 local oldsandbox=${SANDBOX_ON}
652 export SANDBOX_ON="0"
653 case ${CHOST} in
654 *-darwin*)
655 ### Make the user
656 if [[ -z $@ ]] ; then
657 dscl . create /users/${euser} uid ${euid}
658 dscl . create /users/${euser} shell ${eshell}
659 dscl . create /users/${euser} home ${ehome}
660 dscl . create /users/${euser} realname "added by portage for ${PN}"
661 ### Add the user to the groups specified
662 local oldifs=${IFS}
663 export IFS=","
664 for g in ${egroups} ; do
665 dscl . merge /groups/${g} users ${euser}
666 done
667 export IFS=${oldifs}
668 else
669 einfo "Extra options are not supported on Darwin yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: $@"
672 die "Required function missing"
673 fi
674 ;;
675 *-freebsd*|*-dragonfly*)
676 if [[ -z $@ ]] ; then
677 pw useradd ${euser} ${opts} \
678 -c "added by portage for ${PN}" \
679 die "enewuser failed"
680 else
681 einfo " - Extra: $@"
682 pw useradd ${euser} ${opts} \
683 "$@" || die "enewuser failed"
684 fi
685 ;;
686
687 *-netbsd*)
688 if [[ -z $@ ]] ; then
689 useradd ${opts} ${euser} || die "enewuser failed"
690 else
691 einfo " - Extra: $@"
692 useradd ${opts} ${euser} "$@" || die "enewuser failed"
693 fi
694 ;;
695
696 *-openbsd*)
697 if [[ -z $@ ]] ; then
698 useradd -u ${euid} -s ${eshell} \
699 -d ${ehome} -c "Added by portage for ${PN}" \
700 -g ${egroups} ${euser} || die "enewuser failed"
701 else
702 einfo " - Extra: $@"
703 useradd -u ${euid} -s ${eshell} \
704 -d ${ehome} -c "Added by portage for ${PN}" \
705 -g ${egroups} ${euser} "$@" || die "enewuser failed"
706 fi
707 ;;
708
709 *)
710 if [[ -z $@ ]] ; then
711 useradd ${opts} \
712 -c "added by portage for ${PN}" \
713 ${euser} \
714 || die "enewuser failed"
715 else
716 einfo " - Extra: $@"
717 useradd ${opts} "$@" \
718 ${euser} \
719 || die "enewuser failed"
720 fi
721 ;;
722 esac
723
724 if [[ ! -e ${ROOT}/${ehome} ]] ; then
725 einfo " - Creating ${ehome} in ${ROOT}"
726 mkdir -p "${ROOT}/${ehome}"
727 chown ${euser} "${ROOT}/${ehome}"
728 chmod 755 "${ROOT}/${ehome}"
729 fi
730
731 export SANDBOX_ON=${oldsandbox}
732}
733
734# @FUNCTION: enewgroup
735# @USAGE: <group> [gid]
736# @DESCRIPTION:
737# This function does not require you to understand how to properly add a
738# group to the system. Just give it a group name to add and enewgroup will
739# do the rest. You may specify the gid for the group or allow the group to
740# allocate the next available one.
741enewgroup() {
742 case ${EBUILD_PHASE} in
743 unpack|compile|test|install)
744 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
745 eerror "Package fails at QA and at life. Please file a bug."
746 die "Bad package! enewgroup is only for use in pkg_* functions!"
747 esac
748
749 # get the group
750 local egroup="$1"; shift
751 if [ -z "${egroup}" ]
140 then 752 then
141 eerror "Invalid arguments to epatch()" 753 eerror "No group specified !"
142 die "Invalid arguments to epatch()" 754 die "Cannot call enewgroup without a group"
143 fi 755 fi
144 756
145 if [ -n "$1" -a -f "$1" ] 757 # see if group already exists
758 if [[ -n $(egetent group "${egroup}") ]]; then
759 return 0
760 fi
761 einfo "Adding group '${egroup}' to your system ..."
762
763 # options to pass to useradd
764 local opts=
765
766 # handle gid
767 local egid="$1"; shift
768 if [ ! -z "${egid}" ]
146 then 769 then
147 SINGLE_PATCH="yes" 770 if [ "${egid}" -gt 0 ]
148
149 local EPATCH_SOURCE="$1"
150 local EPATCH_SUFFIX="${1##*\.}"
151
152 elif [ -n "$1" -a -d "$1" ]
153 then 771 then
154 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 772 if [ -z "`egetent group ${egid}`" ]
773 then
774 if [[ "${CHOST}" == *-darwin* ]]; then
775 opts="${opts} ${egid}"
776 else
777 opts="${opts} -g ${egid}"
778 fi
779 else
780 egid="next available; requested gid taken"
781 fi
782 else
783 eerror "Groupid given but is not greater than 0 !"
784 die "${egid} is not a valid GID"
785 fi
155 else 786 else
156 if [ ! -d ${EPATCH_SOURCE} ] 787 egid="next available"
788 fi
789 einfo " - Groupid: ${egid}"
790
791 # handle extra
792 local eextra="$@"
793 opts="${opts} ${eextra}"
794
795 # add the group
796 local oldsandbox="${SANDBOX_ON}"
797 export SANDBOX_ON="0"
798 case ${CHOST} in
799 *-darwin*)
800 if [ ! -z "${eextra}" ];
157 then 801 then
158 echo 802 einfo "Extra options are not supported on Darwin/OS X yet"
159 eerror "Cannot find \$EPATCH_SOURCE!" 803 einfo "Please report the ebuild along with the info below"
160 echo 804 einfo "eextra: ${eextra}"
161 die "Cannot find \$EPATCH_SOURCE!" 805 die "Required function missing"
162 fi
163
164 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
165 fi 806 fi
166 807
167 case ${EPATCH_SUFFIX##*\.} in 808 # If we need the next available
168 bz2) 809 case ${egid} in
169 PIPE_CMD="bzip2 -dc" 810 *[!0-9]*) # Non numeric
170 PATCH_SUFFIX="bz2" 811 for ((egid = 101; egid <= 999; egid++)); do
812 [[ -z $(egetent group ${egid}) ]] && break
813 done
814 esac
815 dscl . create /groups/${egroup} gid ${egid}
816 dscl . create /groups/${egroup} passwd '*'
817 ;;
818
819 *-freebsd*|*-dragonfly*)
820 case ${egid} in
821 *[!0-9]*) # Non numeric
822 for ((egid = 101; egid <= 999; egid++)); do
823 [[ -z $(egetent group ${egid}) ]] && break
824 done
825 esac
826 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
827 ;;
828
829 *-netbsd*)
830 case ${egid} in
831 *[!0-9]*) # Non numeric
832 for ((egid = 101; egid <= 999; egid++)); do
833 [[ -z $(egetent group ${egid}) ]] && break
834 done
835 esac
836 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
837 ;;
838
839 *)
840 groupadd ${opts} ${egroup} || die "enewgroup failed"
841 ;;
842 esac
843 export SANDBOX_ON="${oldsandbox}"
844}
845
846# @FUNCTION: edos2unix
847# @USAGE: <file> [more files ...]
848# @DESCRIPTION:
849# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
850# to remove all of these text utilities from DEPEND variables because this
851# is a script based solution. Just give it a list of files to convert and
852# they will all be changed from the DOS CRLF format to the UNIX LF format.
853edos2unix() {
854 echo "$@" | xargs sed -i 's/\r$//'
855}
856
857# Make a desktop file !
858# Great for making those icons in kde/gnome startmenu !
859# Amaze your friends ! Get the women ! Join today !
860#
861# make_desktop_entry(<command>, [name], [icon], [type], [path])
862#
863# binary: what command does the app run with ?
864# name: the name that will show up in the menu
865# icon: give your little like a pretty little icon ...
866# this can be relative (to /usr/share/pixmaps) or
867# a full path to an icon
868# type: what kind of application is this ? for categories:
869# http://standards.freedesktop.org/menu-spec/latest/apa.html
870# path: if your app needs to startup in a specific dir
871make_desktop_entry() {
872 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
873
874 local exec=${1}
875 local name=${2:-${PN}}
876 local icon=${3:-${PN}}
877 local type=${4}
878 local path=${5}
879
880 if [[ -z ${type} ]] ; then
881 local catmaj=${CATEGORY%%-*}
882 local catmin=${CATEGORY##*-}
883 case ${catmaj} in
884 app)
885 case ${catmin} in
886 accessibility) type=Accessibility;;
887 admin) type=System;;
888 antivirus) type=System;;
889 arch) type=Archiving;;
890 backup) type=Archiving;;
891 cdr) type=DiscBurning;;
892 dicts) type=Dictionary;;
893 doc) type=Documentation;;
894 editors) type=TextEditor;;
895 emacs) type=TextEditor;;
896 emulation) type=Emulator;;
897 laptop) type=HardwareSettings;;
898 office) type=Office;;
899 pda) type=PDA;;
900 vim) type=TextEditor;;
901 xemacs) type=TextEditor;;
902 esac
903 ;;
904
905 dev)
906 type="Development"
907 ;;
908
909 games)
910 case ${catmin} in
911 action|fps) type=ActionGame;;
912 arcade) type=ArcadeGame;;
913 board) type=BoardGame;;
914 emulation) type=Emulator;;
915 kids) type=KidsGame;;
916 puzzle) type=LogicGame;;
917 roguelike) type=RolePlaying;;
918 rpg) type=RolePlaying;;
919 simulation) type=Simulation;;
920 sports) type=SportsGame;;
921 strategy) type=StrategyGame;;
922 esac
923 type="Game;${type}"
924 ;;
925
926 gnome)
927 type="Gnome;GTK"
928 ;;
929
930 kde)
931 type="KDE;Qt"
932 ;;
933
934 mail)
935 type="Network;Email"
936 ;;
937
938 media)
939 case ${catmin} in
940 gfx)
941 type=Graphics
942 ;;
943 *)
944 case ${catmin} in
945 radio) type=Tuner;;
946 sound) type=Audio;;
947 tv) type=TV;;
948 video) type=Video;;
949 esac
950 type="AudioVideo;${type}"
951 ;;
952 esac
953 ;;
954
955 net)
956 case ${catmin} in
957 dialup) type=Dialup;;
958 ftp) type=FileTransfer;;
959 im) type=InstantMessaging;;
960 irc) type=IRCClient;;
961 mail) type=Email;;
962 news) type=News;;
963 nntp) type=News;;
964 p2p) type=FileTransfer;;
965 voip) type=Telephony;;
966 esac
967 type="Network;${type}"
968 ;;
969
970 sci)
971 case ${catmin} in
972 astro*) type=Astronomy;;
973 bio*) type=Biology;;
974 calc*) type=Calculator;;
975 chem*) type=Chemistry;;
976 elec*) type=Electronics;;
977 geo*) type=Geology;;
978 math*) type=Math;;
979 physics) type=Physics;;
980 visual*) type=DataVisualization;;
981 esac
982 type="Education;Science;${type}"
983 ;;
984
985 sys)
986 type="System"
987 ;;
988
989 www)
990 case ${catmin} in
991 client) type=WebBrowser;;
992 esac
993 type="Network;${type}"
994 ;;
995
996 *)
997 type=
998 ;;
999 esac
1000 fi
1001 if [ "${SLOT}" == "0" ] ; then
1002 local desktop_name="${PN}"
1003 else
1004 local desktop_name="${PN}-${SLOT}"
1005 fi
1006 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
1007 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
1008
1009 # Don't append another ";" when a valid category value is provided.
1010 type=${type%;}${type:+;}
1011
1012 eshopts_push -s extglob
1013 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1014 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1015 ewarn "allowed in .desktop files if the value is not an absolute path."
1016 icon=${icon%.@(xpm|png|svg)}
1017 fi
1018 eshopts_pop
1019
1020 cat <<-EOF > "${desktop}"
1021 [Desktop Entry]
1022 Name=${name}
1023 Type=Application
1024 Comment=${DESCRIPTION}
1025 Exec=${exec}
1026 TryExec=${exec%% *}
1027 Icon=${icon}
1028 Categories=${type}
1029 EOF
1030
1031 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}"
1032
1033 (
1034 # wrap the env here so that the 'insinto' call
1035 # doesn't corrupt the env of the caller
1036 insinto /usr/share/applications
1037 doins "${desktop}"
1038 )
1039}
1040
1041# @FUNCTION: validate_desktop_entries
1042# @USAGE: [directories]
1043# @MAINTAINER:
1044# Carsten Lohrke <carlo@gentoo.org>
1045# @DESCRIPTION:
1046# Validate desktop entries using desktop-file-utils
1047validate_desktop_entries() {
1048 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1049 einfo "Checking desktop entry validity"
1050 local directories=""
1051 for d in /usr/share/applications $@ ; do
1052 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1053 done
1054 if [[ -n ${directories} ]] ; then
1055 for FILE in $(find ${directories} -name "*\.desktop" \
1056 -not -path '*.hidden*' | sort -u 2>/dev/null)
1057 do
1058 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1059 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1060 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1061 done
1062 fi
1063 echo ""
1064 else
1065 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1066 fi
1067}
1068
1069# @FUNCTION: make_session_desktop
1070# @USAGE: <title> <command> [command args...]
1071# @DESCRIPTION:
1072# Make a GDM/KDM Session file. The title is the file to execute to start the
1073# Window Manager. The command is the name of the Window Manager.
1074#
1075# You can set the name of the file via the ${wm} variable.
1076make_session_desktop() {
1077 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1078 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1079
1080 local title=$1
1081 local command=$2
1082 local desktop=${T}/${wm:-${PN}}.desktop
1083 shift 2
1084
1085 cat <<-EOF > "${desktop}"
1086 [Desktop Entry]
1087 Name=${title}
1088 Comment=This session logs you into ${title}
1089 Exec=${command} $*
1090 TryExec=${command}
1091 Type=XSession
1092 EOF
1093
1094 (
1095 # wrap the env here so that the 'insinto' call
1096 # doesn't corrupt the env of the caller
1097 insinto /usr/share/xsessions
1098 doins "${desktop}"
1099 )
1100}
1101
1102# @FUNCTION: domenu
1103# @USAGE: <menus>
1104# @DESCRIPTION:
1105# Install the list of .desktop menu files into the appropriate directory
1106# (/usr/share/applications).
1107domenu() {
1108 (
1109 # wrap the env here so that the 'insinto' call
1110 # doesn't corrupt the env of the caller
1111 local i j ret=0
1112 insinto /usr/share/applications
1113 for i in "$@" ; do
1114 if [[ -f ${i} ]] ; then
1115 doins "${i}"
1116 ((ret+=$?))
1117 elif [[ -d ${i} ]] ; then
1118 for j in "${i}"/*.desktop ; do
1119 doins "${j}"
1120 ((ret+=$?))
1121 done
1122 else
1123 ((++ret))
1124 fi
1125 done
1126 exit ${ret}
1127 )
1128}
1129
1130# @FUNCTION: newmenu
1131# @USAGE: <menu> <newname>
1132# @DESCRIPTION:
1133# Like all other new* functions, install the specified menu as newname.
1134newmenu() {
1135 (
1136 # wrap the env here so that the 'insinto' call
1137 # doesn't corrupt the env of the caller
1138 insinto /usr/share/applications
1139 newins "$@"
1140 )
1141}
1142
1143# @FUNCTION: doicon
1144# @USAGE: <list of icons>
1145# @DESCRIPTION:
1146# Install the list of icons into the icon directory (/usr/share/pixmaps).
1147# This is useful in conjunction with creating desktop/menu files.
1148doicon() {
1149 (
1150 # wrap the env here so that the 'insinto' call
1151 # doesn't corrupt the env of the caller
1152 local i j ret
1153 insinto /usr/share/pixmaps
1154 for i in "$@" ; do
1155 if [[ -f ${i} ]] ; then
1156 doins "${i}"
1157 ((ret+=$?))
1158 elif [[ -d ${i} ]] ; then
1159 for j in "${i}"/*.png ; do
1160 doins "${j}"
1161 ((ret+=$?))
1162 done
1163 else
1164 ((++ret))
1165 fi
1166 done
1167 exit ${ret}
1168 )
1169}
1170
1171# @FUNCTION: newicon
1172# @USAGE: <icon> <newname>
1173# @DESCRIPTION:
1174# Like all other new* functions, install the specified icon as newname.
1175newicon() {
1176 (
1177 # wrap the env here so that the 'insinto' call
1178 # doesn't corrupt the env of the caller
1179 insinto /usr/share/pixmaps
1180 newins "$@"
1181 )
1182}
1183
1184# for internal use only (unpack_pdv and unpack_makeself)
1185find_unpackable_file() {
1186 local src=$1
1187 if [[ -z ${src} ]] ; then
1188 src=${DISTDIR}/${A}
1189 else
1190 if [[ -e ${DISTDIR}/${src} ]] ; then
1191 src=${DISTDIR}/${src}
1192 elif [[ -e ${PWD}/${src} ]] ; then
1193 src=${PWD}/${src}
1194 elif [[ -e ${src} ]] ; then
1195 src=${src}
1196 fi
1197 fi
1198 [[ ! -e ${src} ]] && return 1
1199 echo "${src}"
1200}
1201
1202# @FUNCTION: unpack_pdv
1203# @USAGE: <file to unpack> <size of off_t>
1204# @DESCRIPTION:
1205# Unpack those pesky pdv generated files ...
1206# They're self-unpacking programs with the binary package stuffed in
1207# the middle of the archive. Valve seems to use it a lot ... too bad
1208# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1209#
1210# You have to specify the off_t size ... I have no idea how to extract that
1211# information out of the binary executable myself. Basically you pass in
1212# the size of the off_t type (in bytes) on the machine that built the pdv
1213# archive.
1214#
1215# One way to determine this is by running the following commands:
1216#
1217# @CODE
1218# strings <pdv archive> | grep lseek
1219# strace -elseek <pdv archive>
1220# @CODE
1221#
1222# Basically look for the first lseek command (we do the strings/grep because
1223# sometimes the function call is _llseek or something) and steal the 2nd
1224# parameter. Here is an example:
1225#
1226# @CODE
1227# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1228# lseek
1229# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1230# lseek(3, -4, SEEK_END) = 2981250
1231# @CODE
1232#
1233# Thus we would pass in the value of '4' as the second parameter.
1234unpack_pdv() {
1235 local src=$(find_unpackable_file "$1")
1236 local sizeoff_t=$2
1237
1238 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1239 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1240
1241 local shrtsrc=$(basename "${src}")
1242 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1243 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1244 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1245
1246 # grab metadata for debug reasons
1247 local metafile=$(emktemp)
1248 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1249
1250 # rip out the final file name from the metadata
1251 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1252 datafile=$(basename "${datafile}")
1253
1254 # now lets uncompress/untar the file if need be
1255 local tmpfile=$(emktemp)
1256 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1257
1258 local iscompressed=$(file -b "${tmpfile}")
1259 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1260 iscompressed=1
1261 mv ${tmpfile}{,.Z}
1262 gunzip ${tmpfile}
1263 else
1264 iscompressed=0
1265 fi
1266 local istar=$(file -b "${tmpfile}")
1267 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1268 istar=1
1269 else
1270 istar=0
1271 fi
1272
1273 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1274 #dd if=${src} ibs=${metaskip} count=1 \
1275 # | dd ibs=${tailskip} skip=1 \
1276 # | gzip -dc \
1277 # > ${datafile}
1278 if [ ${iscompressed} -eq 1 ] ; then
1279 if [ ${istar} -eq 1 ] ; then
1280 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1281 | head -c $((${metaskip}-${tailskip})) \
1282 | tar -xzf -
1283 else
1284 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1285 | head -c $((${metaskip}-${tailskip})) \
1286 | gzip -dc \
1287 > ${datafile}
1288 fi
1289 else
1290 if [ ${istar} -eq 1 ] ; then
1291 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1292 | head -c $((${metaskip}-${tailskip})) \
1293 | tar --no-same-owner -xf -
1294 else
1295 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1296 | head -c $((${metaskip}-${tailskip})) \
1297 > ${datafile}
1298 fi
1299 fi
1300 true
1301 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1302 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1303}
1304
1305# @FUNCTION: unpack_makeself
1306# @USAGE: [file to unpack] [offset] [tail|dd]
1307# @DESCRIPTION:
1308# Unpack those pesky makeself generated files ...
1309# They're shell scripts with the binary package tagged onto
1310# the end of the archive. Loki utilized the format as does
1311# many other game companies.
1312#
1313# If the file is not specified, then ${A} is used. If the
1314# offset is not specified then we will attempt to extract
1315# the proper offset from the script itself.
1316unpack_makeself() {
1317 local src_input=${1:-${A}}
1318 local src=$(find_unpackable_file "${src_input}")
1319 local skip=$2
1320 local exe=$3
1321
1322 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1323
1324 local shrtsrc=$(basename "${src}")
1325 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1326 if [[ -z ${skip} ]] ; then
1327 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1328 local skip=0
1329 exe=tail
1330 case ${ver} in
1331 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1332 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1333 ;;
1334 2.0|2.0.1)
1335 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1336 ;;
1337 2.1.1)
1338 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1339 let skip="skip + 1"
1340 ;;
1341 2.1.2)
1342 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1343 let skip="skip + 1"
1344 ;;
1345 2.1.3)
1346 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1347 let skip="skip + 1"
1348 ;;
1349 2.1.4|2.1.5)
1350 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1351 skip=$(head -n ${skip} "${src}" | wc -c)
1352 exe="dd"
1353 ;;
1354 *)
1355 eerror "I'm sorry, but I was unable to support the Makeself file."
1356 eerror "The version I detected was '${ver}'."
1357 eerror "Please file a bug about the file ${shrtsrc} at"
1358 eerror "http://bugs.gentoo.org/ so that support can be added."
1359 die "makeself version '${ver}' not supported"
1360 ;;
1361 esac
1362 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1363 fi
1364 case ${exe} in
1365 tail) exe="tail -n +${skip} '${src}'";;
1366 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1367 *) die "makeself cant handle exe '${exe}'"
1368 esac
1369
1370 # lets grab the first few bytes of the file to figure out what kind of archive it is
1371 local tmpfile=$(emktemp)
1372 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1373 local filetype=$(file -b "${tmpfile}")
1374 case ${filetype} in
1375 *tar\ archive*)
1376 eval ${exe} | tar --no-same-owner -xf -
171 ;; 1377 ;;
172 gz|Z|z) 1378 bzip2*)
173 PIPE_CMD="gzip -dc" 1379 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
174 PATCH_SUFFIX="gz"
175 ;; 1380 ;;
176 ZIP|zip) 1381 gzip*)
177 PIPE_CMD="unzip -p" 1382 eval ${exe} | tar --no-same-owner -xzf -
178 PATCH_SUFFIX="zip" 1383 ;;
1384 compress*)
1385 eval ${exe} | gunzip | tar --no-same-owner -xf -
179 ;; 1386 ;;
180 *) 1387 *)
181 PIPE_CMD="cat" 1388 eerror "Unknown filetype \"${filetype}\" ?"
182 PATCH_SUFFIX="patch" 1389 false
183 ;; 1390 ;;
184 esac 1391 esac
1392 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1393}
185 1394
186 if [ "${SINGLE_PATCH}" = "no" ] 1395# @FUNCTION: check_license
187 then 1396# @USAGE: [license]
188 einfo "Applying various patches (bugfixes/updates)..." 1397# @DESCRIPTION:
1398# Display a license for user to accept. If no license is
1399# specified, then ${LICENSE} is used.
1400check_license() {
1401 local lic=$1
1402 if [ -z "${lic}" ] ; then
1403 lic="${PORTDIR}/licenses/${LICENSE}"
1404 else
1405 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1406 lic="${PORTDIR}/licenses/${lic}"
1407 elif [ -e "${PWD}/${lic}" ] ; then
1408 lic="${PWD}/${lic}"
1409 elif [ -e "${lic}" ] ; then
1410 lic="${lic}"
189 fi 1411 fi
190 for x in ${EPATCH_SOURCE} 1412 fi
1413 local l="`basename ${lic}`"
1414
1415 # here is where we check for the licenses the user already
1416 # accepted ... if we don't find a match, we make the user accept
1417 local alic
1418 eshopts_push -o noglob # so that bash doesn't expand "*"
1419 for alic in ${ACCEPT_LICENSE} ; do
1420 if [[ ${alic} == ${l} ]]; then
1421 eshopts_pop
1422 return 0
1423 fi
191 do 1424 done
192 # New ARCH dependant patch naming scheme... 1425 eshopts_pop
193 # 1426 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
194 # ???_arch_foo.patch 1427
195 # 1428 local licmsg=$(emktemp)
196 if [ -f ${x} ] && \ 1429 cat <<-EOF > ${licmsg}
197 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] 1430 **********************************************************
198 then 1431 The following license outlines the terms of use of this
1432 package. You MUST accept this license for installation to
1433 continue. When you are done viewing, hit 'q'. If you
1434 CTRL+C out of this, the install will not run!
1435 **********************************************************
1436
1437 EOF
1438 cat ${lic} >> ${licmsg}
1439 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1440 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1441 read alic
1442 case ${alic} in
1443 yes|Yes|y|Y)
1444 return 0
1445 ;;
1446 *)
1447 echo;echo;echo
1448 eerror "You MUST accept the license to continue! Exiting!"
1449 die "Failed to accept license"
1450 ;;
1451 esac
1452}
1453
1454# @FUNCTION: cdrom_get_cds
1455# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1456# @DESCRIPTION:
1457# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1458# the whole 'non-interactive' policy, but damnit I want CD support !
1459#
1460# With these cdrom functions we handle all the user interaction and
1461# standardize everything. All you have to do is call cdrom_get_cds()
1462# and when the function returns, you can assume that the cd has been
1463# found at CDROM_ROOT.
1464#
1465# The function will attempt to locate a cd based upon a file that is on
1466# the cd. The more files you give this function, the more cds
1467# the cdrom functions will handle.
1468#
1469# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1470# etc... If you want to give the cds better names, then just export
1471# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1472# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1473# also use the CDROM_NAME_SET bash array.
1474#
1475# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1476cdrom_get_cds() {
1477 # first we figure out how many cds we're dealing with by
1478 # the # of files they gave us
199 local count=0 1479 local cdcnt=0
200 local popts="${EPATCH_OPTS}" 1480 local f=
1481 for f in "$@" ; do
1482 ((++cdcnt))
1483 export CDROM_CHECK_${cdcnt}="$f"
1484 done
1485 export CDROM_TOTAL_CDS=${cdcnt}
1486 export CDROM_CURRENT_CD=1
201 1487
202 if [ -n "${EPATCH_EXCLUDE}" ] 1488 # now we see if the user gave use CD_ROOT ...
203 then 1489 # if they did, let's just believe them that it's correct
204 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ] 1490 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
205 then 1491 local var=
1492 cdcnt=0
1493 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1494 ((++cdcnt))
1495 var="CD_ROOT_${cdcnt}"
1496 [[ -z ${!var} ]] && var="CD_ROOT"
1497 if [[ -z ${!var} ]] ; then
1498 eerror "You must either use just the CD_ROOT"
1499 eerror "or specify ALL the CD_ROOT_X variables."
1500 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1501 die "could not locate CD_ROOT_${cdcnt}"
1502 fi
1503 done
1504 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1505 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1506 export CDROM_SET=-1
1507 for f in ${CDROM_CHECK_1//:/ } ; do
1508 ((++CDROM_SET))
1509 [[ -e ${CD_ROOT}/${f} ]] && break
1510 done
1511 export CDROM_MATCH=${f}
1512 return
1513 fi
1514
1515 # User didn't help us out so lets make sure they know they can
1516 # simplify the whole process ...
1517 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1518 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1519 echo
1520 einfo "If you do not have the CD, but have the data files"
1521 einfo "mounted somewhere on your filesystem, just export"
1522 einfo "the variable CD_ROOT so that it points to the"
1523 einfo "directory containing the files."
1524 echo
1525 einfo "For example:"
1526 einfo "export CD_ROOT=/mnt/cdrom"
1527 echo
1528 else
1529 if [[ -n ${CDROM_NAME_SET} ]] ; then
1530 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1531 cdcnt=0
1532 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1533 ((++cdcnt))
1534 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1535 done
1536 fi
1537
1538 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1539 cdcnt=0
1540 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1541 ((++cdcnt))
1542 var="CDROM_NAME_${cdcnt}"
1543 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1544 done
1545 echo
1546 einfo "If you do not have the CDs, but have the data files"
1547 einfo "mounted somewhere on your filesystem, just export"
1548 einfo "the following variables so they point to the right place:"
1549 einfon ""
1550 cdcnt=0
1551 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1552 ((++cdcnt))
1553 echo -n " CD_ROOT_${cdcnt}"
1554 done
1555 echo
1556 einfo "Or, if you have all the files in the same place, or"
1557 einfo "you only have one cdrom, you can export CD_ROOT"
1558 einfo "and that place will be used as the same data source"
1559 einfo "for all the CDs."
1560 echo
1561 einfo "For example:"
1562 einfo "export CD_ROOT_1=/mnt/cdrom"
1563 echo
1564 fi
1565
1566 export CDROM_SET=""
1567 export CDROM_CURRENT_CD=0
1568 cdrom_load_next_cd
1569}
1570
1571# @FUNCTION: cdrom_load_next_cd
1572# @DESCRIPTION:
1573# Some packages are so big they come on multiple CDs. When you're done reading
1574# files off a CD and want access to the next one, just call this function.
1575# Again, all the messy details of user interaction are taken care of for you.
1576# Once this returns, just read the variable CDROM_ROOT for the location of the
1577# mounted CD. Note that you can only go forward in the CD list, so make sure
1578# you only call this function when you're done using the current CD.
1579cdrom_load_next_cd() {
1580 local var
1581 ((++CDROM_CURRENT_CD))
1582
1583 unset CDROM_ROOT
1584 var=CD_ROOT_${CDROM_CURRENT_CD}
1585 [[ -z ${!var} ]] && var="CD_ROOT"
1586 if [[ -z ${!var} ]] ; then
1587 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1588 _cdrom_locate_file_on_cd ${!var}
1589 else
1590 export CDROM_ROOT=${!var}
1591 fi
1592
1593 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1594}
1595
1596# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1597# functions. this should *never* be called from an ebuild.
1598# all it does is try to locate a give file on a cd ... if the cd isn't
1599# found, then a message asking for the user to insert the cdrom will be
1600# displayed and we'll hang out here until:
1601# (1) the file is found on a mounted cdrom
1602# (2) the user hits CTRL+C
1603_cdrom_locate_file_on_cd() {
1604 local mline=""
1605 local showedmsg=0 showjolietmsg=0
1606
1607 while [[ -z ${CDROM_ROOT} ]] ; do
1608 local i=0
1609 local -a cdset=(${*//:/ })
1610 if [[ -n ${CDROM_SET} ]] ; then
1611 cdset=(${cdset[${CDROM_SET}]})
1612 fi
1613
1614 while [[ -n ${cdset[${i}]} ]] ; do
1615 local dir=$(dirname ${cdset[${i}]})
1616 local file=$(basename ${cdset[${i}]})
1617
1618 local point= node= fs= foo=
1619 while read point node fs foo ; do
1620 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1621 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
206 continue 1622 && continue
1623 point=${point//\040/ }
1624 [[ ! -d ${point}/${dir} ]] && continue
1625 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1626 export CDROM_ROOT=${point}
1627 export CDROM_SET=${i}
1628 export CDROM_MATCH=${cdset[${i}]}
1629 return
1630 done <<< "$(get_mounts)"
1631
1632 ((++i))
1633 done
1634
1635 echo
1636 if [[ ${showedmsg} -eq 0 ]] ; then
1637 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1638 if [[ -z ${CDROM_NAME} ]] ; then
1639 einfo "Please insert+mount the cdrom for ${PN} now !"
1640 else
1641 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1642 fi
1643 else
1644 if [[ -z ${CDROM_NAME_1} ]] ; then
1645 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1646 else
1647 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1648 einfo "Please insert+mount the ${!var} cdrom now !"
207 fi 1649 fi
208 fi 1650 fi
1651 showedmsg=1
1652 fi
1653 einfo "Press return to scan for the cd again"
1654 einfo "or hit CTRL+C to abort the emerge."
1655 echo
1656 if [[ ${showjolietmsg} -eq 0 ]] ; then
1657 showjolietmsg=1
1658 else
1659 ewarn "If you are having trouble with the detection"
1660 ewarn "of your CD, it is possible that you do not have"
1661 ewarn "Joliet support enabled in your kernel. Please"
1662 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1663 ebeep 5
1664 fi
1665 read || die "something is screwed with your system"
1666 done
1667}
1668
1669# @FUNCTION: strip-linguas
1670# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1671# @DESCRIPTION:
1672# Make sure that LINGUAS only contains languages that
1673# a package can support. The first form allows you to
1674# specify a list of LINGUAS. The -i builds a list of po
1675# files found in all the directories and uses the
1676# intersection of the lists. The -u builds a list of po
1677# files found in all the directories and uses the union
1678# of the lists.
1679strip-linguas() {
1680 local ls newls nols
1681 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1682 local op=$1; shift
1683 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1684 local d f
1685 for d in "$@" ; do
1686 if [[ ${op} == "-u" ]] ; then
1687 newls=${ls}
1688 else
1689 newls=""
209 1690 fi
210 if [ "${SINGLE_PATCH}" = "yes" ] 1691 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
211 then 1692 if [[ ${op} == "-i" ]] ; then
212 if [ -n "${EPATCH_SINGLE_MSG}" ] 1693 hasq ${f} ${ls} && newls="${newls} ${f}"
213 then
214 einfo "${EPATCH_SINGLE_MSG}"
215 else 1694 else
216 einfo "Applying ${x##*/}..." 1695 hasq ${f} ${ls} || newls="${newls} ${f}"
217 fi 1696 fi
1697 done
1698 ls=${newls}
1699 done
1700 else
1701 ls="$@"
1702 fi
1703
1704 nols=""
1705 newls=""
1706 for f in ${LINGUAS} ; do
1707 if hasq ${f} ${ls} ; then
1708 newls="${newls} ${f}"
218 else 1709 else
219 einfo " ${x##*/}..." 1710 nols="${nols} ${f}"
1711 fi
1712 done
1713 [[ -n ${nols} ]] \
1714 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1715 export LINGUAS=${newls:1}
1716}
1717
1718# @FUNCTION: preserve_old_lib
1719# @USAGE: <libs to preserve> [more libs]
1720# @DESCRIPTION:
1721# These functions are useful when a lib in your package changes ABI SONAME.
1722# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1723# would break packages that link against it. Most people get around this
1724# by using the portage SLOT mechanism, but that is not always a relevant
1725# solution, so instead you can call this from pkg_preinst. See also the
1726# preserve_old_lib_notify function.
1727preserve_old_lib() {
1728 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1729 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1730 die "Invalid preserve_old_lib() usage"
1731 fi
1732 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1733
1734 # let portage worry about it
1735 has preserve-libs ${FEATURES} && return 0
1736
1737 local lib dir
1738 for lib in "$@" ; do
1739 [[ -e ${ROOT}/${lib} ]] || continue
1740 dir=${lib%/*}
1741 dodir ${dir} || die "dodir ${dir} failed"
1742 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1743 touch "${D}"/${lib}
1744 done
1745}
1746
1747# @FUNCTION: preserve_old_lib_notify
1748# @USAGE: <libs to notify> [more libs]
1749# @DESCRIPTION:
1750# Spit helpful messages about the libraries preserved by preserve_old_lib.
1751preserve_old_lib_notify() {
1752 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1753 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1754 die "Invalid preserve_old_lib_notify() usage"
1755 fi
1756
1757 # let portage worry about it
1758 has preserve-libs ${FEATURES} && return 0
1759
1760 local lib notice=0
1761 for lib in "$@" ; do
1762 [[ -e ${ROOT}/${lib} ]] || continue
1763 if [[ ${notice} -eq 0 ]] ; then
1764 notice=1
1765 ewarn "Old versions of installed libraries were detected on your system."
1766 ewarn "In order to avoid breaking packages that depend on these old libs,"
1767 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1768 ewarn "in order to remove these old dependencies. If you do not have this"
1769 ewarn "helper program, simply emerge the 'gentoolkit' package."
1770 ewarn
1771 fi
1772 ewarn " # revdep-rebuild --library ${lib##*/}"
1773 done
1774 if [[ ${notice} -eq 1 ]] ; then
1775 ewarn
1776 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1777 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1778 for lib in "$@" ; do
1779 ewarn " # rm '${lib}'"
1780 done
1781 fi
1782}
1783
1784# @FUNCTION: built_with_use
1785# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1786# @DESCRIPTION:
1787#
1788# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1789#
1790# A temporary hack until portage properly supports DEPENDing on USE
1791# flags being enabled in packages. This will check to see if the specified
1792# DEPEND atom was built with the specified list of USE flags. The
1793# --missing option controls the behavior if called on a package that does
1794# not actually support the defined USE flags (aka listed in IUSE).
1795# The default is to abort (call die). The -a and -o flags control
1796# the requirements of the USE flags. They correspond to "and" and "or"
1797# logic. So the -a flag means all listed USE flags must be enabled
1798# while the -o flag means at least one of the listed IUSE flags must be
1799# enabled. The --hidden option is really for internal use only as it
1800# means the USE flag we're checking is hidden expanded, so it won't be found
1801# in IUSE like normal USE flags.
1802#
1803# Remember that this function isn't terribly intelligent so order of optional
1804# flags matter.
1805built_with_use() {
1806 local hidden="no"
1807 if [[ $1 == "--hidden" ]] ; then
1808 hidden="yes"
1809 shift
1810 fi
1811
1812 local missing_action="die"
1813 if [[ $1 == "--missing" ]] ; then
1814 missing_action=$2
1815 shift ; shift
1816 case ${missing_action} in
1817 true|false|die) ;;
1818 *) die "unknown action '${missing_action}'";;
1819 esac
1820 fi
1821
1822 local opt=$1
1823 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1824
1825 local PKG=$(best_version $1)
1826 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1827 shift
1828
1829 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1830 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1831
1832 # if the IUSE file doesn't exist, the read will error out, we need to handle
1833 # this gracefully
1834 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1835 case ${missing_action} in
1836 true) return 0;;
1837 false) return 1;;
1838 die) die "Unable to determine what USE flags $PKG was built with";;
1839 esac
1840 fi
1841
1842 if [[ ${hidden} == "no" ]] ; then
1843 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1844 # Don't check USE_EXPAND #147237
1845 local expand
1846 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1847 if [[ $1 == ${expand}_* ]] ; then
1848 expand=""
1849 break
220 fi 1850 fi
221
222 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
223 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
224
225 # Allow for prefix to differ ... im lazy, so shoot me :/
226 while [ "${count}" -lt 5 ]
227 do
228 # Generate some useful debug info ...
229 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
230 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
231
232 if [ "${PATCH_SUFFIX}" != "patch" ]
233 then
234 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
235 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
236 else
237 PATCH_TARGET="${x}"
238 fi
239
240 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
241 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
242
243 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245
246 if [ "${PATCH_SUFFIX}" != "patch" ]
247 then
248 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
249 then
250 echo
251 eerror "Could not extract patch!"
252 #die "Could not extract patch!"
253 count=5
254 break
255 fi
256 fi
257
258 if patch ${popts} --dry-run -f -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
259 then
260 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
261 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
262 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
263 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
264 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
265
266 patch ${popts} -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
267
268 if [ "$?" -ne 0 ]
269 then
270 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
271 echo
272 eerror "A dry-run of patch command succeeded, but actually"
273 eerror "applying the patch failed!"
274 #die "Real world sux compared to the dreamworld!"
275 count=5
276 fi
277
278 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
279
280 break
281 fi
282
283 count=$((count + 1))
284 done 1851 done
285 1852 if [[ -n ${expand} ]] ; then
286 if [ "${PATCH_SUFFIX}" != "patch" ] 1853 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
287 then 1854 case ${missing_action} in
288 rm -f ${PATCH_TARGET} 1855 true) return 0;;
1856 false) return 1;;
1857 die) die "$PKG does not actually support the $1 USE flag!";;
1858 esac
289 fi 1859 fi
290
291 if [ "${count}" -eq 5 ]
292 then
293 echo
294 eerror "Failed Patch: ${x##*/}!"
295 eerror
296 eerror "Include in your bugreport the contents of:"
297 eerror
298 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
299 echo
300 die "Failed Patch: ${x##*/}!"
301 fi 1860 fi
302
303 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
304
305 eend 0
306 fi 1861 fi
1862
1863 local USE_BUILT=$(<${USEFILE})
1864 while [[ $# -gt 0 ]] ; do
1865 if [[ ${opt} = "-o" ]] ; then
1866 has $1 ${USE_BUILT} && return 0
1867 else
1868 has $1 ${USE_BUILT} || return 1
1869 fi
1870 shift
307 done 1871 done
308 if [ "${SINGLE_PATCH}" = "no" ] 1872 [[ ${opt} = "-a" ]]
309 then 1873}
310 einfo "Done with patching" 1874
1875# @FUNCTION: epunt_cxx
1876# @USAGE: [dir to scan]
1877# @DESCRIPTION:
1878# Many configure scripts wrongly bail when a C++ compiler could not be
1879# detected. If dir is not specified, then it defaults to ${S}.
1880#
1881# http://bugs.gentoo.org/73450
1882epunt_cxx() {
1883 local dir=$1
1884 [[ -z ${dir} ]] && dir=${S}
1885 ebegin "Removing useless C++ checks"
1886 local f
1887 find "${dir}" -name configure | while read f ; do
1888 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1889 done
1890 eend 0
1891}
1892
1893# @FUNCTION: make_wrapper
1894# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1895# @DESCRIPTION:
1896# Create a shell wrapper script named wrapper in installpath
1897# (defaults to the bindir) to execute target (default of wrapper) by
1898# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1899# libpaths followed by optionally changing directory to chdir.
1900make_wrapper() {
1901 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1902 local tmpwrapper=$(emktemp)
1903 # We don't want to quote ${bin} so that people can pass complex
1904 # things as $bin ... "./someprog --args"
1905 cat << EOF > "${tmpwrapper}"
1906#!/bin/sh
1907cd "${chdir:-.}"
1908if [ -n "${libdir}" ] ; then
1909 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1910 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1911 else
1912 export LD_LIBRARY_PATH="${libdir}"
1913 fi
1914fi
1915exec ${bin} "\$@"
1916EOF
1917 chmod go+rx "${tmpwrapper}"
1918 if [[ -n ${path} ]] ; then
1919 (
1920 exeinto "${path}"
1921 newexe "${tmpwrapper}" "${wrapper}"
1922 ) || die
1923 else
1924 newbin "${tmpwrapper}" "${wrapper}" || die
1925 fi
1926}
1927
1928# @FUNCTION: prepalldocs
1929# @USAGE:
1930# @DESCRIPTION:
1931# Compress files in /usr/share/doc which are not already
1932# compressed, excluding /usr/share/doc/${PF}/html.
1933# Uses the ecompressdir to do the compression.
1934# 2009-02-18 by betelgeuse:
1935# Commented because ecompressdir is even more internal to
1936# Portage than prepalldocs (it's not even mentioned in man 5
1937# ebuild). Please submit a better version for review to gentoo-dev
1938# if you want prepalldocs here.
1939#prepalldocs() {
1940# if [[ -n $1 ]] ; then
1941# ewarn "prepalldocs: invalid usage; takes no arguments"
311 fi 1942# fi
312}
313 1943
1944# cd "${D}"
1945# [[ -d usr/share/doc ]] || return 0
1946
1947# find usr/share/doc -exec gzip {} +
1948# ecompressdir --ignore /usr/share/doc/${PF}/html
1949# ecompressdir --queue /usr/share/doc
1950#}

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.339

  ViewVC Help
Powered by ViewVC 1.1.20